#ifndef CANPubDataWrapper_WRAPPER_HEADER_H
#define CANPubDataWrapper_WRAPPER_HEADER_H

#include "pub/PubDataWrapper.h"
#include "../Messages.h"
#include <cstring>
#include "stdlib.h"

#include "can_msg_node/executable.h"

template <typename EventType>
class CAN2SWC_PubDataWrapper : public PubDataWrapper<EventType>
{
	CAN2SWC _data;

public:
    void GetData(ara::com::SampleAllocateePtr<EventType> &data) override
    {
//    	_data.VCU_Info_1_Signals.current_speed = 10.5;

    	  	data->VCU_Info_1_Signals = _data.VCU_Info_1_Signals;
    	  	data->VCU_Info_2_Signals = _data.VCU_Info_2_Signals;
    	  	data->DEVSTATUS_Signals = _data.DEVSTATUS_Signals;
    	  	data->HEADING_ANGLE_Signals = _data.HEADING_ANGLE_Signals;
    	  	data->INS_SOL_RESULT_STATUS_Signals = _data.INS_SOL_RESULT_STATUS_Signals;
    	  	data->INS_SOL_RESULT_VEL_STD_Signals = _data.INS_SOL_RESULT_VEL_STD_Signals;
    	  	data->INS_SOL_RESULT_VEL_Signals = _data.INS_SOL_RESULT_VEL_Signals;
    	  	data->INS_SOL_RESULT_ANGLE_STD_Signals = _data.INS_SOL_RESULT_ANGLE_STD_Signals;
    	  	data->INS_SOL_RESULT_ANGLE_Signals = _data.INS_SOL_RESULT_ANGLE_Signals;
    	  	data->INS_SOL_RESULT_ALTITUDE_Signals = _data.INS_SOL_RESULT_ALTITUDE_Signals;
    	  	data->INS_SOL_RESULT_LONGITUDE_Signals = _data.INS_SOL_RESULT_LONGITUDE_Signals;
    	  	data->INS_SOL_RESULT_LATITUDE_Signals = _data.INS_SOL_RESULT_LATITUDE_Signals;
    	  	data->INS_SOL_RESULT_COMMON_Signals = _data.INS_SOL_RESULT_COMMON_Signals;
    	  	data->GNSS_SOL_RESULT_LATENCY_Signals = _data.GNSS_SOL_RESULT_LATENCY_Signals;
    	  	data->GNSS_SOL_RESULT_SPD_Signals = _data.GNSS_SOL_RESULT_SPD_Signals;
    	  	data->GNSS_SOL_RESULT_ALTITUDE_Signals = _data.GNSS_SOL_RESULT_ALTITUDE_Signals;
    	  	data->GNSS_SOL_RESULT_LONGITUDE_Signals = _data.GNSS_SOL_RESULT_LONGITUDE_Signals;
    	  	data->GNSS_SOL_RESULT_LATITUDE_Signals = _data.GNSS_SOL_RESULT_LATITUDE_Signals;
    	  	data->GNSS_SOL_RESULT_STATUS_Signals = _data.GNSS_SOL_RESULT_STATUS_Signals;
    	  	data->GNSS_SOL_RESULT_COMMON_Signals = _data.GNSS_SOL_RESULT_COMMON_Signals;
    	  	data->GNSS_SOL_RESULT_DOP_Signals = _data.GNSS_SOL_RESULT_DOP_Signals;
    	  	data->GNSS_SOL_RESULT_NUM_Signals = _data.GNSS_SOL_RESULT_NUM_Signals;
    	  	data->IMU_BIAS_CORRECTED_COMMON_Signals = _data.IMU_BIAS_CORRECTED_COMMON_Signals;
    	  	data->IMU_BIAS_CORRECTED_ANGRATE_Signals = _data.IMU_BIAS_CORRECTED_ANGRATE_Signals;
    	  	data->IMU_BIAS_CORRECTED_ACC_Signals = _data.IMU_BIAS_CORRECTED_ACC_Signals;
    	  	data->IMU_ORIGIN_COMMON_Signals = _data.IMU_ORIGIN_COMMON_Signals;
    	  	data->IMU_ORIGIN_ACC_Signals = _data.IMU_ORIGIN_ACC_Signals;
    	  	data->IMU_ORIGIN_GYRO_Signals = _data.IMU_ORIGIN_GYRO_Signals;
    }

    void setAllData(const CAN2SWC& data)
    {
    	_data = data;
    }

};

#endif /*CAN_PUB_DATA_WRAPPERS_H*/
